<template>
  <v-form
      ref="offerForm"
      @submit.prevent=""
  >
    <div v-if="isSignUp">
      <v-text-field
          label="Phone number (Gonna be your username)"
          v-model="form.username"
          outlined
          v-validate="'required'"
          data-vv-name="phone"
          :error-messages="errors.collect('phone')"
      />
      <v-text-field
          label="First name"
          v-model="form.first_name"
          outlined
          v-validate="'required'"
          data-vv-name="first name"
          :error-messages="errors.collect('first name')"
      />
      <v-text-field
          label="Last name"
          v-model="form.last_name"
          outlined
          v-validate="'required'"
          data-vv-name="last name"
          :error-messages="errors.collect('last name')"
      />
      <v-text-field
          label="Email address"
          v-model="form.email"
          outlined
          type="email"
          v-validate="'required'"
          data-vv-name="email"
          :error-messages="errors.collect('email')"
      />
    </div>

    <v-select
        v-model="form.offer_name"
        :items="offersNameWithCost"
        item-text="nameWithCost"
        item-value="name"
        label="Amount of time"
        v-validate="'required'"
        data-vv-name="amount of time"
        :error-messages="errors.collect('amount of time')"
        filled
        outlined
    ></v-select>
    <div v-if="this.cardNumber && !this.isSignUp">
      <v-btn @click="dialog=true" class="saved-card mb-6" :loading="loading"
      >
        <b>Use this card {{ this.cardNumber }}</b>
      </v-btn>
      <div>
        <v-btn v-if="this.cardNumber" @click="formWithNewCardIsShown = !formWithNewCardIsShown "
               class="saved-card mb-10">
          <b>Use new card</b>
          <v-icon class="pl-4">{{ `mdi-arrow-${formWithNewCardIsShown ? 'up' : 'down'}` }}</v-icon>
        </v-btn>
      </div>
    </div>

    <div v-show="this.isSignUp ? true : (!this.cardNumber && !this.isSignUp) || formWithNewCardIsShown">
      <v-text-field
          v-model="form.name_on_card"
          class="mb-4"
          outlined
          label="Name on Card"
          v-validate="'required'"
          data-vv-name="name card"
          :error-messages="errors.collect('name card')"
      ></v-text-field>
      <v-row no-gutters>
        <v-col cols="10">
          <v-text-field
              v-model="cardNumberWithMask"
              class="mb-4"
              outlined
              label="Card Number"
              v-mask="'#### #### #### ####'"
              v-validate="'required|min:18|max:19'"
              data-vv-name="card number"
              :error-messages="errors.collect('card number')"
              @blur="form.card_number = cardNumberWithMask.replace(/\s+/g, '')"
          ></v-text-field>
        </v-col>
        <v-col>
          <v-icon
              large
              class="ml-3 mt-3"
          >
            mdi-credit-card-check-outline
          </v-icon>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="6" sm="4">
          <v-select
              v-model="form.date_mm"
              :items="days"
              label="Month"
              filled
              outlined
              v-validate="'required'"
              data-vv-name="Month"
              :error-messages="errors.collect('Month')"
          ></v-select>
        </v-col>
        <v-col cols="6" sm="4">
          <v-select
              v-model="selectedYear"
              :items="years"
              label="Year"
              filled
              outlined
              @input="selectYearHandler"
              v-validate="'required'"
              data-vv-name="Year"
              :error-messages="errors.collect('Year')"
          ></v-select>
        </v-col>
        <v-col cols="12" sm="4">
          <v-text-field
              v-model="form.cvv"
              class="mb-4"
              outlined
              label="CVV"
              v-mask="'####'"
              v-validate="'required|numeric|min:3|max:4'"
              data-vv-name="cvv"
              :error-messages="errors.collect('cvv')"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row no-gutters>
        <v-checkbox
            class="mt-0 ml-auto"
            v-model="form.is_save_card"
            label="Save this card ?"
        ></v-checkbox>
      </v-row>
      <v-btn
          :class="{'full-width-btn': $vuetify.breakpoint.xsOnly}"
          class="mt-2"
          type="submit"
          color="primary"
          @click="buyOffer"
          :loading="loading"
      >{{ isBtnContent }}
      </v-btn>
    </div>
    <v-dialog
        v-model="dialog"
        max-width="290"
    >
      <ConfirmPay @closeDialog="dialog = false" @confirmOffer="buyOfferWithCard"/>
    </v-dialog>
  </v-form>
</template>

<script>
import {mapState, mapActions} from 'vuex'
import ConfirmPay from "../common/modal/ConfirmPay";

export default {
  name: 'TimeOfferBoard',
  props: {
    isBtnContent: {
      type: String,
      default: 'buy offer'
    },
    isSignUp: {
      type: Boolean,
      default: true
    }
  },
  components: { ConfirmPay },
  data: () => ({
    formWithNewCardIsShown: false,
    form: {
      name_on_card: '',
      card_number: '',
      date_mm: '',
      date_yy: '',
      cvv: '',
      offer_name: '',
      use_saved_card: '',

      first_name: '',
      last_name: '',
      is_save_card: '',
      username: '',
      email: '',
    },
    cardNumberWithMask: '',
    days: ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'],
    years: ['2021', '2022', '2023', '2024', '2025', '2026', '2027', '2028'],
    offers: [],
    selectedYear: '',
    loading: false,
    dialog: false,
  }),
  computed: {
    ...mapState(['username', 'cardNumber', 'currentTime', 'userId']),
    offersNameWithCost() {
      return this.offers.map(item => {
        return {
          name: item.Name,
          nameWithCost: `${item.Name} (${item.CostPrice} $)`
        }
      })
    }

  },
  created() {
    this.fetchOffers()
    if (this.cardNumber && !this.isSignUp) {
      this.formWithNewCardIsShown = false
    }
  },
  methods: {
    ...mapActions(['setNotification', 'setCardNumber']),
    async buyOfferWithCard() {
      try {
        const payload = new FormData()
        this.form.use_saved_card = true

        for (const key in this.form) {
          payload.append(key, this.form[key])
        }

        const isValid = await this.$validator.validate('amount of time')
        if (isValid) {
          this.loading = true

          const response = await this.$axios.post(this.isSignUp ? `/api/signup` : `/api/users/buyOffer/${this.username}/${this.form.offer_name}`, payload)

          if (response.status === 200) {
            this.clearForm()
            this.setNotification({
              show: true,
              type: 'success',
              message: response.data.message
            })
            this.$eventBus.$emit('updateUser', response.data.user);
            if (this.isSignUp) {
              await this.$router.push({name: 'success-signup'});
            }
          }
        }
        this.$refs.offerForm.reset()
      } catch (error) {
        console.log(error)
      } finally {
        this.loading = false
      }
    },
    async buyOffer() {
      try {
        if (!this.isSignUp) {
          delete this.form.username
          delete this.form.email
        }
        this.form.use_saved_card = false

        const isValid = await this.$validator.validate();

        if (isValid) {

          const payload = new FormData()

          for (const key in this.form) {
            payload.append(key, this.form[key])
          }

          this.loading = true

          const response = await this.$axios.post(this.isSignUp ? `/api/signup` : `/api/users/buyOffer/${this.username}/${this.form.offer_name}`, payload)

          if (response.status === 200) {
            this.clearForm()
            this.setNotification({
              show: true,
              type: 'success',
              message: response.data.message
            })
            this.$eventBus.$emit('updateUser', response.data.user)
            this.setCardNumber({
              cardNumber: response.data.user.cardNumber
            })

            if (this.isSignUp) {
              await this.$router.push({name: 'success-signup'});
            }
          }
          this.$refs.offerForm.reset()
          this.formWithNewCardIsShown = false
        }
      } catch (error) {
        console.log(error)
      } finally {
        this.loading = false
      }
    },
    async fetchOffers() {
      try {
        const response = await this.$axios.get('/api/sloffers')

        if (response.status === 200) {
          this.offers = response.data
        }
      } catch (error) {
        console.log(error)
      }
    },
    clearForm() {
      Object.keys(this.form).forEach(key => this.form[key] = null)
      this.form.offer_name = null
      this.cardNumberWithMask = null
    },
    selectYearHandler() {
      this.form.date_yy = this.selectedYear?.toString().slice(-2)
    },
  }
}
</script>

<style lang="scss" scoped>
.saved-card {
  width: 100%;
}

</style>
